﻿package {

	import alamboley.datastructures.DoublyLinkedList;
	import alamboley.datastructures.DoublyLinkedListNode;
	import alamboley.datastructures.PooledSprite;
	import alamboley.utils.FPSMemCounter;

	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;


	[SWF(backgroundColor="#000000", frameRate="24", width="600", height="500")]

	/**
	 * @author Aymeric
	 */
	public class Main extends Sprite {

		private const _INIT_OBJECTS:uint = 500;
		private const _BIG_CIRCLE_RADIUS:uint = 200;
		private const _CIRCLE_RADIUS:uint = 2;

		private var _container:Sprite;
		private var _pool:PooledSprite;
		private var _tf:TextField;

		private var _radius:uint = 200;
		private var _radiusIncrease:Boolean = false;

		public function Main() {

			FPSMemCounter.init(stage, this, true);

			var doublyLinkedList:DoublyLinkedList = new DoublyLinkedList();
			var node:DoublyLinkedListNode = new DoublyLinkedListNode(6);
			doublyLinkedList.append(2);
			doublyLinkedList.prepend(5);
			doublyLinkedList.append(7);
			doublyLinkedList.appendNode(node);
			trace(doublyLinkedList.content());

			doublyLinkedList.removeNode(node);
			doublyLinkedList.append(9);

			trace(doublyLinkedList.content());

			_container = new Sprite();

			addChild(_container);
			_container.x = stage.stageWidth * 0.5;
			_container.y = stage.stageHeight * 0.5;

			_initButtons();

			stage.addEventListener(Event.ENTER_FRAME, _ef);

			_pool = new PooledSprite(PointCircle, _INIT_OBJECTS, 50);
			
			var i:uint = 0;
			for (i = 0; i < _INIT_OBJECTS; ++i) {
				trace('Creating Point ', _pool.length);
				_container.addChild(_pool.create(_CIRCLE_RADIUS).data);
			}
			
			_tf.text = String(_pool.length) + " objects";
		}

		private function _ef(evt:Event):void {
			
			if (_radiusIncrease == true) {
				
				++_radius;
				if (_radius > _BIG_CIRCLE_RADIUS) {
					_radiusIncrease = false;
				}
				
			} else {
				
				--_radius;
				if (_radius < 25) {
					_radiusIncrease = true;
				}
				
			}
			
			_pool.update(_radius);
		}

		private function _removeObjects(mEvt:MouseEvent):void {

			if (_pool.length > 50) {
				var i:uint = 0;
				for ( i = 0; i < 50; ++i ) {
					trace('Disposing Point', _pool.length);
					_container.removeChild(_pool.disposeGraphicObject(_pool.tail).data);
				}
				_tf.text = String(_pool.length) + " objects";
			}
		}

		private function _addObjects(mEvt:MouseEvent):void {

			var i:uint = 0;
			for (i = 0; i < 50; ++i) {
				trace('Creating Point ', _pool.length);
				_container.addChild(_pool.create(_CIRCLE_RADIUS).data);
			}
			_tf.text = String(_pool.length) + " objects";
		}

		private function _initButtons():void {

			var addObject:Sprite = new Sprite();
			addObject.graphics.beginFill(0x0000FF);
			addObject.graphics.drawRect(0, 0, 75, 30);
			addObject.graphics.endFill();
			addObject.x = 500;
			addObject.y = 380;
			addChild(addObject);
			addObject.buttonMode = true;
			addObject.addEventListener(MouseEvent.CLICK, _addObjects);

			var addObjectText:TextField = new TextField();
			addObjectText.selectable = false;
			addObjectText.mouseEnabled = false;
			addObjectText.textColor = 0x00FF00;
			addObject.addChild(addObjectText);
			addObjectText.text = "Add 50 objects";
			addObjectText.y = 10;

			var removeObject:Sprite = new Sprite();
			removeObject.graphics.beginFill(0xFF0000);
			removeObject.graphics.drawRect(0, 0, 75, 30);
			removeObject.graphics.endFill();
			removeObject.x = 500;
			removeObject.y = 430;
			addChild(removeObject);
			removeObject.buttonMode = true;
			removeObject.addEventListener(MouseEvent.CLICK, _removeObjects);

			var removeObjectText:TextField = new TextField();
			removeObjectText.selectable = false;
			removeObjectText.mouseEnabled = false;
			removeObjectText.textColor = 0x00FF00;
			removeObject.addChild(removeObjectText);
			removeObjectText.text = "Remove 50";
			removeObjectText.y = 10;

			_tf = new TextField();
			_tf.selectable = false;
			_tf.mouseEnabled = false;
			_tf.x = 30;
			_tf.y = 450;
			_tf.textColor = 0x00FF00;
			addChild(_tf);
		}
	}
}
